
#ifndef DATALOGDATALOGPARSER_H
#define DATALOGDATALOGPARSER_H

#include <string>
#include"datalog.tab.h"
#include"datalogtree.h"
// Tell Flex the lexer's prototype ...
# define YY_DECL                                        \
       datalog::DatalogParser::token_type                         \
       yylex (datalog::DatalogParser::semantic_type* yylval,      \
              datalog::DatalogParser::location_type* yylloc,      \
              DatalogParser& parser)
     // ... and declare it for the parser's sake.
YY_DECL;
using namespace std;
namespace datalog {

/**
This is the main parser class for data log,  it maintains a grammar tree for datalog elements. 

	@author xujian <shelbyxu@gmail.com>
*/
class DatalogParser{
public:
    DatalogParser();
    ~DatalogParser();
    void scan_begin();
    void scan_end();
    int parse(const istream& in);
    void pushin(DatalogTree* t);
    void Init();
private: 
  string filename;
  vector<DatalogTree*> rules;
};

}

#endif
